#!/bin/bash

set -e

function duilder_docs()
{
	PRJ="${1}"
	VER="${2}"
	EXPORT_PATH="${3}"

	echo "Copying docs to [${EXPORT_PATH}]..."
	for f in README License LICENCE Changelog TODO FAQ INSTALL; do
		if [ -r "${f}" ]; then
			cp -vp "${f}" "${EXPORT_PATH}/"
		fi
	done

	if [ -d "screenshot" ]; then
		echo "Copying screenshots..."
		mkdir -p "${EXPORT_PATH}"
		cp -vp screenshot/* "${EXPORT_PATH}/"
	fi
}

function duilder_git()
{
	PRJ="${1}"
	GIT_DEST="${2}"
	EXPORT_GIT="${3}"
	EXPORT_PATH="${4}"
	GIT_CHANGELOG="${5}"

	if [ "${EXPORT_GIT}" != "1" ]; then
		exit 0
	fi

	if [ ! -d .git ]; then
		exit 0
	fi

	if [ -z "${GIT_DEST}" ]; then
		GIT_DEST="${EXPORT_PATH}"
	fi

	echo "Generate GIT tree for HTTP transport..."
	if [ ! -d "${GIT_DEST}/${PRJ}.git" ]; then
		git-clone --bare . "${GIT_DEST}/${PRJ}.git"
		chmod a+x "${GIT_DEST}/${PRJ}.git/hooks/post-update"
		echo "${PRJ}" > "${GIT_DEST}/${PRJ}.git/description"
		# allow export by git daemon?
		#touch "${GIT_DEST}/${PRJ}.git/git-daemon-export-ok
	else
		# --force?
		git-push -v --all "${GIT_DEST}/${PRJ}.git"
		git-push -v --tags "${GIT_DEST}/${PRJ}.git"
	fi
	(cd "${GIT_DEST}/${PRJ}.git" && git-update-server-info)


	if [ "${GIT_CHANGELOG}" = "1" ]; then
		echo "Generating Changelog from git..."
		echo -n > Changelog
		prev=""
		git-tag -l | sort -r | \
		while read tag; do
			if [ "${tag:0:1}" != "v" ]; then
				# skip other kind of tags beside versions
				continue
			fi
			if [ ! -z "${prev}" ]; then
				echo "[${tag} -> ${prev}]" >> Changelog
				echo >> Changelog
				git-shortlog ${tag}..${prev} >> Changelog
				echo >> Changelog
			fi
			prev=${tag}
		done
	fi
}

function duilder_srpm()
{
	PRJ="${1}"
	VER="${2}"
	EXPORT_PATH="${3}"
	BUILD_SRPM="${4}"
	SRPM_DEST="${5}"
	SRPM_POST_RUN="${6}"

	P="${PRJ}-${VER}"

	if [ "${BUILD_SRPM}" != "1" ]; then
		exit 0
	fi

	echo "Building SRPM..."
	rpmbuild -ts "${P}.tar.gz"

	PKG="/usr/src/redhat/SRPMS/${P}-1.src.rpm"

	if [ ! -z "${SRPM_DEST}" ]; then
		echo "Copying to [${SRPM_DEST}]..."
		cp -vp "${PKG}" "${SRPM_DEST}/"
	fi

	echo "Copying to export dir [${EXPORT_PATH}]..."
	mkdir -p "${EXPORT_PATH}"
	cp -vp "${PKG}" "${EXPORT_PATH}/"

	if [ -x "${SRPM_POST_RUN}" ]; then
		echo "Running post SRPM build script [${SRPM_POST_RUN}]..."
		${SRPM_POST_RUN} "${PKG}"
	fi
}

function duilder_tar()
{
	PRJ="${1}"
	VER="${2}"
	EXPORT_PATH="${3}"
	EXCLUDE="${4}"

	P="${PRJ}-${VER}"

	echo "Generating tarball [${P}.tar.gz]..."
	ADD=""
	if [ ! -z "${EXCLUDE}" ]; then
		ADD="--exclude-from \"${EXCLUDE}\""
	fi

	(cd .. && rm -f "${P}" && ln -s "${PRJ}" "${P}")
	tar czhf "${P}.tar.gz" \
		--exclude '.git' \
		--exclude ./Makefile \
	        --exclude "${P}.tar.gz" \
		${ADD} \
	        -C .. "${P}"
	echo "Done generating tarball!"

	rm -f "../${P}"

	echo "Copying source to ${EXPORT_PATH}/..."
	mkdir -p "${EXPORT_PATH}"
	cp -vp "${P}.tar.gz" "${EXPORT_PATH}/"
}

####################################################################

###### Multiplexer
if [ "${1}" = "docs" ]; then
	shift
	duilder_docs "$@"
	exit $?
fi

if [ "${1}" = "tar" ]; then
	shift
	duilder_tar "$@"
	exit $?
fi

if [ "${1}" = "git" ]; then
	shift
	duilder_git "$@"
	exit $?
fi

if [ "${1}" = "srpm" ]; then
	shift
	duilder_srpm "$@"
	exit $?
fi

if [ ! -r duilder.conf ]; then
	echo "You must build a duilder.conf file!"
	exit 1
fi


###### Main stuff

source ${PWD}/duilder.conf

if [ -z "${PRJ}" ]; then
	echo "ERROR: PRJ= parameter is missing."
	exit 1
fi

if [ -z "${VER}" ]; then
	echo "ERROR: PRJ= parameter is missing."
	exit 1
fi

if [ -z "${REV}" ]; then
	echo "ERROR: REV= parameter is missing."
	exit 1
fi

echo
echo "Duilder builder script"
echo "Copyright Catalin(ux) M BOIE"
echo
echo "PRJ=${PRJ}, VER=${VER}, REV=${REV}"
echo "System: `uname -a`"

ETC="/etc"
BIN="/bin"
USR_BIN="/usr/bin"
USR_SBIN="/usr/sbin"
USR_INCLUDE="/usr/include"
USR_LIB="/usr/lib"
USR_SHARE_DOC="/usr/share/doc/${PRJ}-${VER}"
SBIN="/usr/sbin"
VAR_LOG="/var/log/${PRJ}"

while [ "${1}" != "" ]; do
	VAR="`echo ${1} | cut -d'=' -f1`"
	VAL="`echo ${1} | cut -d'=' -f2`"
	case ${VAR} in
		--sysconfdir)
			ETC="${VAL}"
			;;
		--bindir)
			USR_BIN="${VAL}"
			;;
		--sbindir)
			USR_SBIN="${VAL}"
			;;
		--includedir)
			USR_INCLUDE="${VAL}"
			;;
		--libdir)
			USR_LIB="${VAL}"
			;;
	esac
	shift
done

# Truncate future sed file
> tmp.sed

DB_SUPPORT=0

echo -n "Searching for PostgreSQL..."
PG_FOUND=0
PG_VERSION=""
set +e
PG_VERSION="`pg_config --version 2>/dev/null`"
set -e
if [ -z "${PG_VERSION}" ]; then
	echo " not found."
else
	echo " found version ${PG_VERSION}."
	PG_FOUND=1
	PG_INC="${DB_INC} -I`pg_config --includedir`"
	PG_LIB="${DB_INC} -L`pg_config --libdir` -lpq"
	DB_SUPPORT=1
fi

echo -n "Searching for epoll..."
set +e
echo -e "#include <sys/epoll.h> \n int main(void) { return epoll_create(64); }" | gcc -x c -pipe - -o /dev/null 2>/dev/null
set -e
E="${?}"
if [ "${E}" != "0" ]; then
	echo " not found."
	echo "s#@EPOLL_FOUND@#0#g" >> tmp.sed
else
	echo " found."
	echo "s#@EPOLL_FOUND@#1#g" >> tmp.sed
fi

# generic stuff
echo "s#@PRJ@#${PRJ}#g" >> tmp.sed
echo "s#@VER@#${VER}#g" >> tmp.sed
echo "s#@REV@#${REV}#g" >> tmp.sed
echo "s#@ETC@#${ETC}#g" >> tmp.sed
echo "s#@BIN@#${BIN}#g" >> tmp.sed
echo "s#@USR_BIN@#${USR_BIN}#g" >> tmp.sed
echo "s#@SBIN@#${SBIN}#g" >> tmp.sed
echo "s#@USR_SBIN@#${USR_SBIN}#g" >> tmp.sed
echo "s#@VAR_LOG@#${VAR_LOG}#g" >> tmp.sed
echo "s#@USR_INCLUDE@#${USR_INCLUDE}#g" >> tmp.sed
echo "s#@USR_INC@#${USR_INCLUDE}#g" >> tmp.sed
echo "s#@USR_LIB@#${USR_LIB}#g" >> tmp.sed
echo "s#@USR_SHARE_DOC@#${USR_SHARE_DOC}#g" >> tmp.sed
# PG stuff
echo "s#@PG_VERSION@#${PG_VERSION}#g" >> tmp.sed
echo "s#@PG_FOUND@#${PG_FOUND}#g" >> tmp.sed
echo "s#@PG_INC@#${PG_INC}#g" >> tmp.sed
echo "s#@PG_LIB@#${PG_LIB}#g" >> tmp.sed
# DB stuff
echo "s#@DB_SUPPORT@#${DB_SUPPORT}#g" >> tmp.sed
# Export stuff
echo "s#@EXPORT_PATH@#${EXPORT_PATH}#g" >> tmp.sed



if [ -r Makefile.in ]; then
	echo "Building Makefile..."
	echo -n > Makefile
	echo "# duilder header starts #" >> Makefile
	echo "export PRJ := ${PRJ}" >> Makefile
	echo "export VER := ${VER}" >> Makefile
	echo "export REV := ${REV}" >> Makefile
	echo "export DESTDIR" >> Makefile
	echo >> Makefile
	echo "export I_ETC := \$(DESTDIR)${ETC}" >> Makefile
	echo "export I_BIN := \$(DESTDIR)${BIN}" >> Makefile
	echo "export I_SBIN := \$(DESTDIR)${SBIN}" >> Makefile
	echo "export I_USR_BIN := \$(DESTDIR)${USR_BIN}" >> Makefile
	echo "export I_USR_SBIN := \$(DESTDIR)${USR_SBIN}" >> Makefile
	echo "export I_USR_INCLUDE := \$(DESTDIR)${USR_INCLUDE}" >> Makefile
	echo "export I_USR_INC := \$(DESTDIR)${USR_INCLUDE}" >> Makefile
	echo "export I_USR_SHARE_DOC := \$(DESTDIR)${USR_SHARE_DOC}" >> Makefile
	echo "export I_USR_LIB := \$(DESTDIR)${USR_LIB}" >> Makefile
	echo "export I_LIB := \$(DESTDIR)${USR_LIB}" >> Makefile
	echo "export I_VAR_LOG := \$(DESTDIR)${VAR_LOG}" >> Makefile
	echo >> Makefile
	echo "# DB stuff" >> Makefile
	echo "export DB_SUPPORT := ${DB_SUPPORT}" >> Makefile
	echo "# PG" >> Makefile
	echo "export PG_FOUND := ${PG_FOUND}" >> Makefile
	echo "export PG_INC := ${PG_INC}" >> Makefile
	echo "export PG_LIB := ${PG_LIB}" >> Makefile
	echo >> Makefile
	echo "# duilder header ends #" >> Makefile
	echo >> Makefile

	sed -f tmp.sed Makefile.in >> Makefile

	echo >> Makefile
	echo "# duilder tail starts #" >> Makefile
	echo >> Makefile
	echo "# This is to allow exporting only the git tree" >> Makefile
	echo "dist_git:" >> Makefile
	echo "	@./duilder git \"\$(PRJ)\" \"${GIT_DEST}\" \"${EXPORT_GIT}\" \"${EXPORT_PATH}\" \"${GIT_CHANGELOG}\"" >> Makefile
	echo >> Makefile
	echo ".PHONY: dist" >> Makefile
	echo "dist: clean" >> Makefile
	echo "	@./duilder git \"\$(PRJ)\" \"${GIT_DEST}\" \"${EXPORT_GIT}\" \"${EXPORT_PATH}\" \"${GIT_CHANGELOG}\"" >> Makefile
	echo "	@./duilder tar \"\$(PRJ)\" \"\$(VER)\" \"${EXPORT_PATH}\" \"${EXCLUDE}\"" >> Makefile
	echo "	@./duilder srpm \"\$(PRJ)\" \"\$(VER)\" \"${EXPORT_PATH}\" \"${BUILD_SRPM}\" \"${SRPM_DEST}\" \"${SRPM_POST_RUN}\"" >> Makefile
	echo "	@./duilder docs \"\$(PRJ)\" \"\$(VER)\" \"${EXPORT_PATH}\"" >> Makefile
	echo "	@rm -f \"\$(PRJ)-\$(VER).tar.gz\"" >> Makefile
	echo >> Makefile
fi

if [ -r "${PRJ}.spec.in" ]; then
	echo "Generate .spec file..."
	sed -f tmp.sed ${PRJ}.spec.in > ${PRJ}.spec
fi

if [ -r config.h.in ]; then
	echo "Generate config.h file..."
	sed -f tmp.sed config.h.in > config.h
fi

rm -f tmp.sed

if [ "`basename ${0}`" = "duilderx" ]; then
	echo "Clone myself to destination as 'duilder'..."
	cp -vpf "${0}" ${PWD}/duilder
fi

echo "Done. Run make."
